      subroutine Lfun(r,n,fk,L,Lfk,Lfksum,S,Sinv,eigenv,Lamst,post,
     1               xi,expmt,pai)
      implicit none
      integer r,n,i,j,k,m
      double precision fk(n,r,r), L(n+1,r), S(n,r,r), Sinv(n,r,r)
      double precision eigenv(n,r), Lamst(n,r,r), post(n,r,r), xi(n)
      double precision expmt(n,r,r), pai(r), Lfk(n,r), Lfksum(n)
      j=1
      do while (j .LE. r)
        L(1,j)=pai(j)
        j=j+1
      enddo
      i=1
      do while (i .LE. n)
        call fkfun(r,n,S,Sinv,eigenv,Lamst,post,xi(i),expmt,fk)
        Lfksum(i)=0.0
        j=1
        Lfk(i,j)=0.0
        do while (j .LE. r)
          k=1
          do while (k .LE. r)
            Lfk(i,j)=Lfk(i,j)+L(i,k)*fk(i,k,j)
            k=k+1
          enddo
          Lfksum(i)=Lfksum(i)+Lfk(i,j)
          j=j+1
        enddo
        m=1
        do while (m .LE. r)
          L(i+1,m)=Lfk(i,m)/Lfksum(i)
          m=m+1
        enddo
        i=i+1
      enddo
      end



      subroutine Rfun(r,n,fk,RR,Rfk,L,Lfk,Lfksum,S,Sinv,eigenv,
     1                Lamst,post,xi,expmt,pai)
      implicit none
      integer r,n,i,j,k
      double precision fk(n,r,r), L(n+1,r), S(n,r,r), Sinv(n,r,r)
      double precision eigenv(n,r), Lamst(n,r,r), post(n,r,r)
      double precision expmt(n,r,r), pai(r), Lfk(n,r), Lfksum(n)
      double precision RR(n+1,r), xi(n), Rfk(n,r)
      j=1
      do while (j .LE. r)
        RR(n+1,j)=1.0
        j=j+1
      enddo
      call Lfun(r,n,fk,L,Lfk,Lfksum,S,Sinv,eigenv,Lamst,post,
     1          xi,expmt,pai)
      i=n
      do while (i .GE. 1)
        call fkfun(r,n,S,Sinv,eigenv,Lamst,post,xi(i),expmt,fk)
        j=1
        do while (j .LE. r)
          Rfk(i,j)=0.0
          k=1
          do while (k .LE. r)
            Rfk(i,j)=Rfk(i,j)+fk(i,j,k)*RR(i+1,k)
            k=k+1
          enddo
          RR(i,j)=Rfk(i,j)/Lfksum(i)
          j=j+1
        enddo
        i=i-1
      enddo
      end



      subroutine Cfun(r,n,fk,RR,Rfk,L,Lfk,Lfksum,S,Sinv,eigenv,
     1                Lamst,post,xi,expmt,pai,Q,tem,C)
      implicit none
      integer r,n,i,j,k,m
      double precision fk(n,r,r), L(n+1,r), S(n,r,r), Sinv(n,r,r)
      double precision eigenv(n,r), Lamst(n,r,r), post(n,r,r)
      double precision expmt(n,r,r), pai(r), Lfk(n,r), Lfksum(n)
      double precision RR(n+1,r), xi(n), Rfk(n,r), Q(r,r)
      double precision tem(n,r), C(n,2*r,2*r)
      call Rfun(r,n,fk,RR,Rfk,L,Lfk,Lfksum,S,Sinv,eigenv,
     1                Lamst,post,xi,expmt,pai)
      k=1
      do while (k .LE. n)
        j=1
        do while (j .LE. r)
          i=1
          do while (i .LE. r)
            C(k,i,j)=Q(i,j)-Lamst(k,i,j)
            i=i+1
          enddo
          j=j+1
        enddo
        k=k+1
      enddo
      k=1
      do while (k .LE. n)
       j=1
        do while (j .LE. r)
          i=r+1
          do while (i .LE. (2*r))
            C(k,i,j)=0.0
            i=i+1
          enddo
          j=j+1
        enddo
        k=k+1
      enddo
      k=1
      do while (k .LE. n)
        j=r+1
        do while (j .LE. (2*r))
          i=1
          do while (i .LE. r)
            tem(k,i)=0.0
            m=1
            do while (m .LE. r)
              tem(k,i)=tem(k,i)+Lamst(k,i,m)*RR(k+1,m)
              m=m+1
            enddo
            C(k,i,j)=tem(k,i)*L(k,j-r)
            i=i+1
          enddo
          j=j+1
        enddo
        k=k+1
      enddo
      k=1
      do while (k .LE. n)
        j=r+1
        do while (j .LE. (2*r))
         i=r+1
          do while (i .LE. (2*r)) 
            C(k,i,j)=Q(i-r,j-r)-Lamst(k,i-r,j-r)
            i=i+1
          enddo
          j=j+1
        enddo
        k=k+1
      enddo
      end



      subroutine Icfun(r,n,fk,L,Lfk,Lfksum,S,Sinv,eigenv,Lamst,
     1                 post,xi,expmt,pai,Ik,Ic)
      implicit none
      integer r,n,i,j,k
      double precision fk(n,r,r), L(n+1,r), S(n,r,r), Sinv(n,r,r)
      double precision eigenv(n,r), Lamst(n,r,r), post(n,r,r), xi(n)
      double precision expmt(n,r,r), pai(r), Lfk(n,r), Lfksum(n)
      double precision Ik(n,r,r), Ic(r,r)
      call Lfun(r,n,fk,L,Lfk,Lfksum,S,Sinv,eigenv,Lamst,post,
     1          xi,expmt,pai)
      i=1
      do while (i .LE. r)
        j=1
        do while (j .LE. r)
          Ic(i,j)=0.0
          k=1
          do while (k .LE. n)
            Ic(i,j)=Ic(i,j)+Ik(k,j,i)/Lfksum(k)
            k=k+1
          enddo
          j=j+1
        enddo
        i=i+1
      enddo
      end



      subroutine wDfun(r,n,fk,L,Lfk,Lfksum,S,Sinv,eigenv,Lamst,
     1                 post,xi,expmt,pai,Ik,Ic,Q,w,D)
      implicit none
      integer r,n,i,j
      double precision fk(n,r,r), L(n+1,r), S(n,r,r), Sinv(n,r,r)
      double precision eigenv(n,r), Lamst(n,r,r), post(n,r,r), xi(n)
      double precision expmt(n,r,r), pai(r), Lfk(n,r), Lfksum(n)
      double precision Ik(n,r,r), Ic(r,r)
      double precision Q(r,r), w(r,r), D(r)
      call Icfun(r,n,fk,L,Lfk,Lfksum,S,Sinv,eigenv,Lamst,
     1                 post,xi,expmt,pai,Ik,Ic)
      i=1
      do while (i .LE. r)
        j=1
        do while (j .LE. r)
          w(i,j)=Q(i,j)*Ic(i,j)
          j=j+1
        enddo
        D(i)=w(i,i)/Q(i,i)
        i=i+1
      enddo
      end



      subroutine LL1(r,n,fk,L,Lfk,Lfksum,S,Sinv,eigenv,Lamst,post,
     1               xi,expmt,pai,LL)
      implicit none
      integer r,n,i
      double precision fk(n,r,r), L(n+1,r), S(n,r,r), Sinv(n,r,r)
      double precision eigenv(n,r), Lamst(n,r,r), post(n,r,r), xi(n)
      double precision expmt(n,r,r), pai(r), Lfk(n,r), Lfksum(n), LL
      call Lfun(r,n,fk,L,Lfk,Lfksum,S,Sinv,eigenv,Lamst,post,
     1          xi,expmt,pai)
      LL=0.0
      i=1
      do while (i .LE. n)
        LL=LL+dlog(Lfksum(i))
        i=i+1
      enddo
      end



      subroutine Bfun(r,n,fk,RR,Rfk,L,Lfk,Lfksum,S,Sinv,eigenv,
     1                Lamst,post,xi,expmt,pai,B)
      implicit none
      integer r,n,i,j
      double precision fk(n,r,r), L(n+1,r), S(n,r,r), Sinv(n,r,r)
      double precision eigenv(n,r), Lamst(n,r,r), post(n,r,r)
      double precision expmt(n,r,r), pai(r), Lfk(n,r), Lfksum(n)
      double precision RR(n+1,r), xi(n), Rfk(n,r), B(r,n)
      call Rfun(r,n,fk,RR,Rfk,L,Lfk,Lfksum,S,Sinv,eigenv,
     1                Lamst,post,xi,expmt,pai)
      i=1
      do while (i .LE. r)
        j=1
        do while (j .LE. n)
          B(i,j)=L(j+1,i)*RR(j+1,i)
          j=j+1
        enddo
        i=i+1
      enddo
      end
